// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f ipaddresspools.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    pub use std::collections::BTreeMap;
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// IPAddressPoolSpec defines the desired state of IPAddressPool.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "metallb.io",
    version = "v1beta1",
    kind = "IPAddressPool",
    plural = "ipaddresspools"
)]
#[kube(namespaced)]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct IPAddressPoolSpec {
    /// A list of IP address ranges over which MetalLB has authority.
    /// You can list multiple ranges in a single pool, they will all share the
    /// same settings. Each range can be either a CIDR prefix, or an explicit
    /// start-end range of IPs.
    #[cfg_attr(feature = "builder", builder(default))]
    pub addresses: Vec<String>,
    /// AutoAssign flag used to prevent MetallB from automatic allocation
    /// for a pool.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "autoAssign"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub auto_assign: Option<bool>,
    /// AvoidBuggyIPs prevents addresses ending with .0 and .255
    /// to be used by a pool.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "avoidBuggyIPs"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub avoid_buggy_i_ps: Option<bool>,
    /// AllocateTo makes ip pool allocation to specific namespace and/or service.
    /// The controller will use the pool with lowest value of priority in case of
    /// multiple matches. A pool with no priority set will be used only if the
    /// pools with priority can't be used. If multiple matching IPAddressPools are
    /// available it will check for the availability of IPs sorting the matching
    /// IPAddressPools by priority, starting from the highest to the lowest. If
    /// multiple IPAddressPools have the same priority, choice will be random.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "serviceAllocation"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub service_allocation: Option<IPAddressPoolServiceAllocation>,
}

/// AllocateTo makes ip pool allocation to specific namespace and/or service.
/// The controller will use the pool with lowest value of priority in case of
/// multiple matches. A pool with no priority set will be used only if the
/// pools with priority can't be used. If multiple matching IPAddressPools are
/// available it will check for the availability of IPs sorting the matching
/// IPAddressPools by priority, starting from the highest to the lowest. If
/// multiple IPAddressPools have the same priority, choice will be random.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolServiceAllocation {
    /// NamespaceSelectors list of label selectors to select namespace(s) for ip pool,
    /// an alternative to using namespace list.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "namespaceSelectors"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub namespace_selectors: Option<Vec<IPAddressPoolServiceAllocationNamespaceSelectors>>,
    /// Namespaces list of namespace(s) on which ip pool can be attached.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub namespaces: Option<Vec<String>>,
    /// Priority priority given for ip pool while ip allocation on a service.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub priority: Option<i64>,
    /// ServiceSelectors list of label selector to select service(s) for which ip pool
    /// can be used for ip allocation.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "serviceSelectors"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub service_selectors: Option<Vec<IPAddressPoolServiceAllocationServiceSelectors>>,
}

/// A label selector is a label query over a set of resources. The result of matchLabels and
/// matchExpressions are ANDed. An empty label selector matches all objects. A null
/// label selector matches no objects.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolServiceAllocationNamespaceSelectors {
    /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchExpressions"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_expressions:
        Option<Vec<IPAddressPoolServiceAllocationNamespaceSelectorsMatchExpressions>>,
    /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels
    /// map is equivalent to an element of matchExpressions, whose key field is "key", the
    /// operator is "In", and the values array contains only "value". The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchLabels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_labels: Option<BTreeMap<String, String>>,
}

/// A label selector requirement is a selector that contains values, a key, and an operator that
/// relates the key and values.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolServiceAllocationNamespaceSelectorsMatchExpressions {
    /// key is the label key that the selector applies to.
    pub key: String,
    /// operator represents a key's relationship to a set of values.
    /// Valid operators are In, NotIn, Exists and DoesNotExist.
    pub operator: String,
    /// values is an array of string values. If the operator is In or NotIn,
    /// the values array must be non-empty. If the operator is Exists or DoesNotExist,
    /// the values array must be empty. This array is replaced during a strategic
    /// merge patch.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub values: Option<Vec<String>>,
}

/// A label selector is a label query over a set of resources. The result of matchLabels and
/// matchExpressions are ANDed. An empty label selector matches all objects. A null
/// label selector matches no objects.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolServiceAllocationServiceSelectors {
    /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchExpressions"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_expressions:
        Option<Vec<IPAddressPoolServiceAllocationServiceSelectorsMatchExpressions>>,
    /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels
    /// map is equivalent to an element of matchExpressions, whose key field is "key", the
    /// operator is "In", and the values array contains only "value". The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchLabels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_labels: Option<BTreeMap<String, String>>,
}

/// A label selector requirement is a selector that contains values, a key, and an operator that
/// relates the key and values.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolServiceAllocationServiceSelectorsMatchExpressions {
    /// key is the label key that the selector applies to.
    pub key: String,
    /// operator represents a key's relationship to a set of values.
    /// Valid operators are In, NotIn, Exists and DoesNotExist.
    pub operator: String,
    /// values is an array of string values. If the operator is In or NotIn,
    /// the values array must be non-empty. If the operator is Exists or DoesNotExist,
    /// the values array must be empty. This array is replaced during a strategic
    /// merge patch.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub values: Option<Vec<String>>,
}

/// IPAddressPoolStatus defines the observed state of IPAddressPool.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct IPAddressPoolStatus {}
